//Source file: <name_of_source_file>
//Date: <date>
//<information>

package org.csapi.jr.se.cc.gccs;

/**
 * Defines the Tagged Choice of Data Elements that specify additional call report information for certain types of reports.
 *
 */
public final class CallAdditionalReportInfo implements java.io.Serializable {

    private CallReportType _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new CallAdditionalReportInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public CallAdditionalReportInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a CallReportType value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public CallReportType getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a Busy
     * 
     * @return  a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.gccs.CallReleaseCause getBusy() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_BUSY) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.gccs.CallReleaseCause) _object);
    }

    /**
     * This method sets a Busy
     * 
     * @param value a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     */
    public void setBusy(org.csapi.jr.se.cc.gccs.CallReleaseCause value) {
        _discriminator = CallReportType.CALL_REPORT_BUSY;
        _object = value;
    }

    /**
     * This method returns a CallDisconnect
     * 
     * @return  a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.gccs.CallReleaseCause getCallDisconnect() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_DISCONNECT) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.gccs.CallReleaseCause) _object);
    }

    /**
     * This method sets a CallDisconnect
     * 
     * @param value a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     */
    public void setCallDisconnect(org.csapi.jr.se.cc.gccs.CallReleaseCause value) {
        _discriminator = CallReportType.CALL_REPORT_DISCONNECT;
        _object = value;
    }

    /**
     * This method returns a ForwardAddress
     * 
     * @return  a org.csapi.jr.se.Address value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.Address getForwardAddress() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_REDIRECTED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.Address) _object);
    }

    /**
     * This method sets a ForwardAddress
     * 
     * @param value a org.csapi.jr.se.Address value
     */
    public void setForwardAddress(org.csapi.jr.se.Address value) {
        _discriminator = CallReportType.CALL_REPORT_REDIRECTED;
        _object = value;
    }

    /**
     * This method returns a RoutingFailure
     * 
     * @return  a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.gccs.CallReleaseCause getRoutingFailure() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_ROUTING_FAILURE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.gccs.CallReleaseCause) _object);
    }

    /**
     * This method sets a RoutingFailure
     * 
     * @param value a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     */
    public void setRoutingFailure(org.csapi.jr.se.cc.gccs.CallReleaseCause value) {
        _discriminator = CallReportType.CALL_REPORT_ROUTING_FAILURE;
        _object = value;
    }

    /**
     * This method returns a ServiceCode
     * 
     * @return  a org.csapi.jr.se.cc.CallServiceCode value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.CallServiceCode getServiceCode() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_SERVICE_CODE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.CallServiceCode) _object);
    }

    /**
     * This method sets a ServiceCode
     * 
     * @param value a org.csapi.jr.se.cc.CallServiceCode value
     */
    public void setServiceCode(org.csapi.jr.se.cc.CallServiceCode value) {
        _discriminator = CallReportType.CALL_REPORT_SERVICE_CODE;
        _object = value;
    }

    /**
     * This method returns a NotReachable
     * 
     * @return  a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public org.csapi.jr.se.cc.gccs.CallReleaseCause getNotReachable() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_NOT_REACHABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((org.csapi.jr.se.cc.gccs.CallReleaseCause) _object);
    }

    /**
     * This method sets a NotReachable
     * 
     * @param value a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     */
    public void setNotReachable(org.csapi.jr.se.cc.gccs.CallReleaseCause value) {
        _discriminator = CallReportType.CALL_REPORT_NOT_REACHABLE;
        _object = value;
    }

    /**
     * This method returns a QueueStatus
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getQueueStatus() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != CallReportType.CALL_REPORT_QUEUED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a QueueStatus
     * 
     * @param value a java.lang.String value
     */
    public void setQueueStatus(java.lang.String value) {
        _discriminator = CallReportType.CALL_REPORT_QUEUED;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a CallReportType value 
     */ 
    public void setUndefined(CallReportType discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof CallAdditionalReportInfo)) {
            return false;
        } else {
            CallAdditionalReportInfo callAdditionalReportInfo= (CallAdditionalReportInfo)o;
            if(!(this._object.equals(callAdditionalReportInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(callAdditionalReportInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallAdditionalReportInfo

