//Source file: <name_of_source_file>
//Date: <date>
//<information>

package org.csapi.jr.se.cc.gccs;

/**
 * Defines the type of call application-related specific information.
 *
 */
public final class CallAppInfoType implements java.io.Serializable {

    private int _value;
    private static int _size = 9;
    private static CallAppInfoType[] _array = new CallAppInfoType[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private CallAppInfoType(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * Undefined
     */
    public static final int _CALL_APP_UNDEFINED =  0;

    /**
     * Undefined
     */
    public static final CallAppInfoType CALL_APP_UNDEFINED = new CallAppInfoType(_CALL_APP_UNDEFINED);

    /**
     * The alerting mechanism or pattern to use
     */
    public static final int _CALL_APP_ALERTING_MECHANISM =  1;

    /**
     * The alerting mechanism or pattern to use
     */
    public static final CallAppInfoType CALL_APP_ALERTING_MECHANISM = new CallAppInfoType(_CALL_APP_ALERTING_MECHANISM);

    /**
     * The network access type (for example ISDN)
     */
    public static final int _CALL_APP_NETWORK_ACCESS_TYPE =  2;

    /**
     * The network access type (for example ISDN)
     */
    public static final CallAppInfoType CALL_APP_NETWORK_ACCESS_TYPE = new CallAppInfoType(_CALL_APP_NETWORK_ACCESS_TYPE);

    /**
     * Indicates the tele-service (for example telephony) 
     */
    public static final int _CALL_APP_TELE_SERVICE =  3;

    /**
     * Indicates the tele-service (for example telephony) 
     */
    public static final CallAppInfoType CALL_APP_TELE_SERVICE = new CallAppInfoType(_CALL_APP_TELE_SERVICE);

    /**
     * Indicates the bearer service (for example 64kbit/s unrestricted data)
     */
    public static final int _CALL_APP_BEARER_SERVICE =  4;

    /**
     * Indicates the bearer service (for example 64kbit/s unrestricted data)
     */
    public static final CallAppInfoType CALL_APP_BEARER_SERVICE = new CallAppInfoType(_CALL_APP_BEARER_SERVICE);

    /**
     * The category of the calling party
     */
    public static final int _CALL_APP_PARTY_CATEGORY =  5;

    /**
     * The category of the calling party
     */
    public static final CallAppInfoType CALL_APP_PARTY_CATEGORY = new CallAppInfoType(_CALL_APP_PARTY_CATEGORY);

    /**
     * The address to be presented to other call parties
     */
    public static final int _CALL_APP_PRESENTATION_ADDRESS =  6;

    /**
     * The address to be presented to other call parties
     */
    public static final CallAppInfoType CALL_APP_PRESENTATION_ADDRESS = new CallAppInfoType(_CALL_APP_PRESENTATION_ADDRESS);

    /**
     * Carries unspecified service-service information
     */
    public static final int _CALL_APP_GENERIC_INFO =  7;

    /**
     * Carries unspecified service-service information
     */
    public static final CallAppInfoType CALL_APP_GENERIC_INFO = new CallAppInfoType(_CALL_APP_GENERIC_INFO);

    /**
     * Indicates an additional address
     */
    public static final int _CALL_APP_ADDITIONAL_ADDRESS =  8;

    /**
     * Indicates an additional address
     */
    public static final CallAppInfoType CALL_APP_ADDITIONAL_ADDRESS = new CallAppInfoType(_CALL_APP_ADDITIONAL_ADDRESS);


    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the CallAppInfoType object
     */
    public String getValueText() {
        switch (_value) {
            case _CALL_APP_UNDEFINED:
                return "CALL_APP_UNDEFINED";
            case _CALL_APP_ALERTING_MECHANISM:
                return "CALL_APP_ALERTING_MECHANISM";
            case _CALL_APP_NETWORK_ACCESS_TYPE:
                return "CALL_APP_NETWORK_ACCESS_TYPE";
            case _CALL_APP_TELE_SERVICE:
                return "CALL_APP_TELE_SERVICE";
            case _CALL_APP_BEARER_SERVICE:
                return "CALL_APP_BEARER_SERVICE";
            case _CALL_APP_PARTY_CATEGORY:
                return "CALL_APP_PARTY_CATEGORY";
            case _CALL_APP_PRESENTATION_ADDRESS:
                return "CALL_APP_PRESENTATION_ADDRESS";
            case _CALL_APP_GENERIC_INFO:
                return "CALL_APP_GENERIC_INFO";
            case _CALL_APP_ADDITIONAL_ADDRESS:
                return "CALL_APP_ADDITIONAL_ADDRESS";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 8
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static CallAppInfoType getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallAppInfoType)) {
            return false;
        }
        CallAppInfoType callAppInfoType = (CallAppInfoType) o; 
        if(!(this.getValue() == callAppInfoType.getValue())) {
            return false;
        }
        if (this.hashCode() != callAppInfoType.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallAppInfoType

