//Source file: CallControlManager.java
//Date: February 2004
//Generic Call Control Interfaces for 3GPP TS 29.198-04-2 V6.0.0, Release 6

package org.csapi.jr.se.cc.gccs;

/**
 * This interface represents a CallControlManager.<BR>
 *
 */
public interface CallControlManager extends org.csapi.jr.se.Service {

    /**
     * Adds a CallControlManagerListener which is interested in events generated by the CallControlManager.
     *
     * @param  callControlManagerListener  A reference to the CallControlManagerListener which is to be added as
     *         a listener.
     */
    void addCallControlManagerListener(org.csapi.jr.se.cc.gccs.CallControlManagerListener callControlManagerListener);

    /**
     * Removes a CallControlManagerListener which is no longer interested in events generated by the CallControlManager.
     *
     * @param  callControlManagerListener  A reference to the CallControlManagerListener which is to be removed as
     *         a listener.
     */
    void removeCallControlManagerListener(org.csapi.jr.se.cc.gccs.CallControlManagerListener callControlManagerListener);

    /**
     * Invokes the getCriteria() method on the Parlay Gateway.
     */
    org.csapi.jr.se.cc.gccs.CallEventCriteriaResult[] getCriteria()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException;

    /**
     * Invokes the createCall() method on the Parlay Gateway and returns a reference to a transient interface.
     */
    org.csapi.jr.se.cc.gccs.Call createCall()
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.InvalidInterfaceTypeException;

    /**
     * Creates a CallLoadControl object and returns a reference to the interface used to gain access
     * to it's methods.
     *
     * @return  A reference to the CallLoadControl interface.
     */
    org.csapi.jr.se.cc.gccs.CallLoadControl createCallLoadControl();

    /**
     * Creates a CallNotification object and returns a reference to the interface used to gain access
     * to it's methods.
     *
     * @return  A reference to the CallNotification interface.
     */
    org.csapi.jr.se.cc.gccs.CallNotification createCallNotification();

}
