//Source file: CallControlManagerListener.java
//Date: February 2004
//Generic Call Control Interfaces for 3GPP TS 29.198-04-2 V6.0.0, Release 6

package org.csapi.jr.se.cc.gccs;

/**
 * This interface is to be implemented for receiving events issued by the CallControlManager service object.<BR>
 *
 */
public interface CallControlManagerListener extends java.util.EventListener {


   /**
    * Called due to a Gateway initiated call to the callAborted() method on 
    * the callback interface.
    *
    * <BR><BR>MANUAL_UPDATE_REQUIRED Unable to determine correct activity listener
    * interface(s). Move to the correct activity listener interface(s). In some
    * cases you may have to move the method to more than one location, for example
    * onAbortActionResEvent() in the UI service should be moved to the
    * DeleteMessageActivity, RecordMessageActivity, CallRelatedSendInfo and
    * CallRelatedSendInfoAndCollect classes.
    *
    * @param  callAbortedEvent  Reference to a CallAbortedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallAbortedEvent(org.csapi.jr.se.cc.gccs.CallAbortedEvent callAbortedEvent);


   /**
    * Called due to a Gateway initiated call to the callEventNotify() method on 
    * the callback interface.
    *
    * <BR><BR>MANUAL_UPDATE_REQUIRED Unable to determine correct activity listener
    * interface(s). Move to the correct activity listener interface(s). In some
    * cases you may have to move the method to more than one location, for example
    * onAbortActionResEvent() in the UI service should be moved to the
    * DeleteMessageActivity, RecordMessageActivity, CallRelatedSendInfo and
    * CallRelatedSendInfoAndCollect classes.
    *
    * @param  callEventNotifyEvent  Reference to a CallEventNotifyEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallEventNotifyEvent(org.csapi.jr.se.cc.gccs.CallEventNotifyEvent callEventNotifyEvent);


   /**
    * Called due to a Gateway initiated call to the callNotificationInterrupted() method on 
    * the callback interface.
    *
    * @param  callNotificationInterruptedEvent  Reference to a CallNotificationInterruptedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallNotificationInterruptedEvent(org.csapi.jr.se.cc.gccs.CallNotificationInterruptedEvent callNotificationInterruptedEvent);


   /**
    * Called due to a Gateway initiated call to the callNotificationContinued() method on 
    * the callback interface.
    *
    * @param  callNotificationContinuedEvent  Reference to a CallNotificationContinuedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallNotificationContinuedEvent(org.csapi.jr.se.cc.gccs.CallNotificationContinuedEvent callNotificationContinuedEvent);


   /**
    * Called due to a Gateway initiated call to the callOverloadEncountered() method on 
    * the callback interface.
    *
    * <BR><BR>MANUAL_UPDATE_REQUIRED Unable to determine correct activity listener
    * interface(s). Move to the correct activity listener interface(s). In some
    * cases you may have to move the method to more than one location, for example
    * onAbortActionResEvent() in the UI service should be moved to the
    * DeleteMessageActivity, RecordMessageActivity, CallRelatedSendInfo and
    * CallRelatedSendInfoAndCollect classes.
    *
    * @param  callOverloadEncounteredEvent  Reference to a CallOverloadEncounteredEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallOverloadEncounteredEvent(org.csapi.jr.se.cc.gccs.CallOverloadEncounteredEvent callOverloadEncounteredEvent);


   /**
    * Called due to a Gateway initiated call to the callOverloadCeased() method on 
    * the callback interface.
    *
    * <BR><BR>MANUAL_UPDATE_REQUIRED Unable to determine correct activity listener
    * interface(s). Move to the correct activity listener interface(s). In some
    * cases you may have to move the method to more than one location, for example
    * onAbortActionResEvent() in the UI service should be moved to the
    * DeleteMessageActivity, RecordMessageActivity, CallRelatedSendInfo and
    * CallRelatedSendInfoAndCollect classes.
    *
    * @param  callOverloadCeasedEvent  Reference to a CallOverloadCeasedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallOverloadCeasedEvent(org.csapi.jr.se.cc.gccs.CallOverloadCeasedEvent callOverloadCeasedEvent);

}

