//Source file: <name_of_source_file>
//Date: <date>
//<information>

package org.csapi.jr.se.cc.gccs;

/**
 * Defines the Sequence of Data Elements that specify the criteria for an event notification.
Of the addresses only the Plan and the AddrString are used for the purpose of matching the notifications against the criteria.
 * 
 */
public final class CallEventCriteria implements java.io.Serializable {

    private org.csapi.jr.se.AddressRange destinationAddress;
    private org.csapi.jr.se.AddressRange originatingAddress;
    private int callEventName;
    private org.csapi.jr.se.cc.gccs.CallNotificationType callNotificationType;
    private org.csapi.jr.se.cc.CallMonitorMode monitorMode;

    /**
     * Creates a new CallEventCriteria instance.
     */
    public CallEventCriteria () {}

    /**
     * Creates a new CallEventCriteria instance.
     * @param _destinationAddress   Defines the destination address or address range for which the notification is requested.
     * @param _originatingAddress   Defines the origination address or an address range for which the notification is requested.
     * @param _callEventName   Name of the event(s)
     * @param _callNotificationType   Indicates whether it is related to the originating or the terminating user in the call.
     * @param _monitorMode   Defines the mode that the call is in following the notification.
Monitor mode P_CALL_MONITOR_MODE_DO_NOT_MONITOR is not a legal value here.
     */
    public CallEventCriteria (org.csapi.jr.se.AddressRange _destinationAddress, org.csapi.jr.se.AddressRange _originatingAddress, int _callEventName, org.csapi.jr.se.cc.gccs.CallNotificationType _callNotificationType, org.csapi.jr.se.cc.CallMonitorMode _monitorMode) {

        this.destinationAddress = _destinationAddress;
        this.originatingAddress = _originatingAddress;
        this.callEventName = _callEventName;
        this.callNotificationType = _callNotificationType;
        this.monitorMode = _monitorMode;
    }

    /**
     * This method returns a destinationAddress.
     * 
     * @return a org.csapi.jr.se.AddressRange value
     */
    public org.csapi.jr.se.AddressRange getDestinationAddress() {
        return destinationAddress;
    }

    /**
     * This method returns a originatingAddress.
     * 
     * @return a org.csapi.jr.se.AddressRange value
     */
    public org.csapi.jr.se.AddressRange getOriginatingAddress() {
        return originatingAddress;
    }

    /**
     * This method returns a callEventName.
     * 
     * @return a int value
     */
    public int getCallEventName() {
        return callEventName;
    }

    /**
     * This method returns a callNotificationType.
     * 
     * @return a org.csapi.jr.se.cc.gccs.CallNotificationType value
     */
    public org.csapi.jr.se.cc.gccs.CallNotificationType getCallNotificationType() {
        return callNotificationType;
    }

    /**
     * This method returns a monitorMode.
     * 
     * @return a org.csapi.jr.se.cc.CallMonitorMode value
     */
    public org.csapi.jr.se.cc.CallMonitorMode getMonitorMode() {
        return monitorMode;
    }


    /**
     * This method sets a destinationAddress.
     */ 
    public void setDestinationAddress(org.csapi.jr.se.AddressRange destinationAddress) {
        this.destinationAddress = destinationAddress;
    }

    /**
     * This method sets a originatingAddress.
     */ 
    public void setOriginatingAddress(org.csapi.jr.se.AddressRange originatingAddress) {
        this.originatingAddress = originatingAddress;
    }

    /**
     * This method sets a callEventName.
     */ 
    public void setCallEventName(int callEventName) {
        this.callEventName = callEventName;
    }

    /**
     * This method sets a callNotificationType.
     */ 
    public void setCallNotificationType(org.csapi.jr.se.cc.gccs.CallNotificationType callNotificationType) {
        this.callNotificationType = callNotificationType;
    }

    /**
     * This method sets a monitorMode.
     */ 
    public void setMonitorMode(org.csapi.jr.se.cc.CallMonitorMode monitorMode) {
        this.monitorMode = monitorMode;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallEventCriteria)) {
            return false;
        } 
        CallEventCriteria callEventCriteria = (CallEventCriteria) o;
        if ((this.monitorMode != null) && (callEventCriteria.monitorMode != null)) {
            if(!(this.monitorMode.equals(callEventCriteria.monitorMode))) {
                return false;
            }
        }
        if(!(this.callEventName == callEventCriteria.callEventName))  {
            return false;
        }
        if ((this.callNotificationType != null) && (callEventCriteria.callNotificationType != null)) {
            if(!(this.callNotificationType.equals(callEventCriteria.callNotificationType))) {
                return false;
            }
        }
        if ((this.destinationAddress != null) && (callEventCriteria.destinationAddress != null)) {
            if(!(this.destinationAddress.equals(callEventCriteria.destinationAddress))) {
                return false;
            }
        }
        if ((this.originatingAddress != null) && (callEventCriteria.originatingAddress != null)) {
            if(!(this.originatingAddress.equals(callEventCriteria.originatingAddress))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallEventCriteria

