//Source file: CallListener.java
//Date: February 2004
//Generic Call Control Interfaces for 3GPP TS 29.198-04-2 V6.0.0, Release 6

package org.csapi.jr.se.cc.gccs;

/**
 * This interface is to be implemented for receiving events issued by the Call service object.<BR>
 *
 */
public interface CallListener extends java.util.EventListener {


   /**
    * Called due to a Gateway initiated call to the routeRes() method on 
    * the callback interface.
    *
    * <BR><BR>MANUAL_UPDATE_REQUIRED Unable to determine correct activity listener
    * interface(s). Move to the correct activity listener interface(s). In some
    * cases you may have to move the method to more than one location, for example
    * onAbortActionResEvent() in the UI service should be moved to the
    * DeleteMessageActivity, RecordMessageActivity, CallRelatedSendInfo and
    * CallRelatedSendInfoAndCollect classes.
    *
    * @param  routeResEvent  Reference to a RouteResEvent event 
    *        emmited from the impl or activity object. 
    */
    void onRouteResEvent(org.csapi.jr.se.cc.gccs.RouteResEvent routeResEvent);


   /**
    * Called due to a Gateway initiated call to the routeErr() method on 
    * the callback interface.
    *
    * <BR><BR>MANUAL_UPDATE_REQUIRED Unable to determine correct activity listener
    * interface(s). Move to the correct activity listener interface(s). In some
    * cases you may have to move the method to more than one location, for example
    * onAbortActionResEvent() in the UI service should be moved to the
    * DeleteMessageActivity, RecordMessageActivity, CallRelatedSendInfo and
    * CallRelatedSendInfoAndCollect classes.
    *
    * @param  routeErrEvent  Reference to a RouteErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onRouteErrEvent(org.csapi.jr.se.cc.gccs.RouteErrEvent routeErrEvent);


   /**
    * Called due to a Gateway initiated call to the getCallInfoRes() method on 
    * the callback interface.
    *
    * @param  getCallInfoResEvent  Reference to a GetCallInfoResEvent event 
    *        emmited from the impl or activity object. 
    */
    void onGetCallInfoResEvent(org.csapi.jr.se.cc.gccs.GetCallInfoResEvent getCallInfoResEvent);


   /**
    * Called due to a Gateway initiated call to the getCallInfoErr() method on 
    * the callback interface.
    *
    * @param  getCallInfoErrEvent  Reference to a GetCallInfoErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onGetCallInfoErrEvent(org.csapi.jr.se.cc.gccs.GetCallInfoErrEvent getCallInfoErrEvent);


   /**
    * Called due to a Gateway initiated call to the superviseCallRes() method on 
    * the callback interface.
    *
    * @param  superviseCallResEvent  Reference to a SuperviseCallResEvent event 
    *        emmited from the impl or activity object. 
    */
    void onSuperviseCallResEvent(org.csapi.jr.se.cc.gccs.SuperviseCallResEvent superviseCallResEvent);


   /**
    * Called due to a Gateway initiated call to the superviseCallErr() method on 
    * the callback interface.
    *
    * @param  superviseCallErrEvent  Reference to a SuperviseCallErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onSuperviseCallErrEvent(org.csapi.jr.se.cc.gccs.SuperviseCallErrEvent superviseCallErrEvent);


   /**
    * Called due to a Gateway initiated call to the callFaultDetected() method on 
    * the callback interface.
    *
    * @param  callFaultDetectedEvent  Reference to a CallFaultDetectedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallFaultDetectedEvent(org.csapi.jr.se.cc.gccs.CallFaultDetectedEvent callFaultDetectedEvent);


   /**
    * Called due to a Gateway initiated call to the getMoreDialledDigitsRes() method on 
    * the callback interface.
    *
    * @param  getMoreDialledDigitsResEvent  Reference to a GetMoreDialledDigitsResEvent event 
    *        emmited from the impl or activity object. 
    */
    void onGetMoreDialledDigitsResEvent(org.csapi.jr.se.cc.gccs.GetMoreDialledDigitsResEvent getMoreDialledDigitsResEvent);


   /**
    * Called due to a Gateway initiated call to the getMoreDialledDigitsErr() method on 
    * the callback interface.
    *
    * @param  getMoreDialledDigitsErrEvent  Reference to a GetMoreDialledDigitsErrEvent event 
    *        emmited from the impl or activity object. 
    */
    void onGetMoreDialledDigitsErrEvent(org.csapi.jr.se.cc.gccs.GetMoreDialledDigitsErrEvent getMoreDialledDigitsErrEvent);


   /**
    * Called due to a Gateway initiated call to the callEnded() method on 
    * the callback interface.
    *
    * @param  callEndedEvent  Reference to a CallEndedEvent event 
    *        emmited from the impl or activity object. 
    */
    void onCallEndedEvent(org.csapi.jr.se.cc.gccs.CallEndedEvent callEndedEvent);

}

