//Source file: <name_of_source_file>
//Date: <date>
//<information>

package org.csapi.jr.se.cc.gccs;

/**
 * Defines a specific call event report type.
 *
 */
public final class CallReportType implements java.io.Serializable {

    private int _value;
    private static int _size = 12;
    private static CallReportType[] _array = new CallReportType[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private CallReportType(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * Undefined.
     */
    public static final int _CALL_REPORT_UNDEFINED =  0;

    /**
     * Undefined.
     */
    public static final CallReportType CALL_REPORT_UNDEFINED = new CallReportType(_CALL_REPORT_UNDEFINED);

    /**
     * Call routing progress event: an indication from the network that progress has been made in routing the call to the requested call party. This message may be sent more than once, or may not be sent at all by the gateway with respect to routing a given call leg to a given address.
     */
    public static final int _CALL_REPORT_PROGRESS =  1;

    /**
     * Call routing progress event: an indication from the network that progress has been made in routing the call to the requested call party. This message may be sent more than once, or may not be sent at all by the gateway with respect to routing a given call leg to a given address.
     */
    public static final CallReportType CALL_REPORT_PROGRESS = new CallReportType(_CALL_REPORT_PROGRESS);

    /**
     * Call is alerting at the call party.
     */
    public static final int _CALL_REPORT_ALERTING =  2;

    /**
     * Call is alerting at the call party.
     */
    public static final CallReportType CALL_REPORT_ALERTING = new CallReportType(_CALL_REPORT_ALERTING);

    /**
     * Call answered at address.
     */
    public static final int _CALL_REPORT_ANSWER =  3;

    /**
     * Call answered at address.
     */
    public static final CallReportType CALL_REPORT_ANSWER = new CallReportType(_CALL_REPORT_ANSWER);

    /**
     * Called address refused call due to busy.
     */
    public static final int _CALL_REPORT_BUSY =  4;

    /**
     * Called address refused call due to busy.
     */
    public static final CallReportType CALL_REPORT_BUSY = new CallReportType(_CALL_REPORT_BUSY);

    /**
     * No answer at called address.
     */
    public static final int _CALL_REPORT_NO_ANSWER =  5;

    /**
     * No answer at called address.
     */
    public static final CallReportType CALL_REPORT_NO_ANSWER = new CallReportType(_CALL_REPORT_NO_ANSWER);

    /**
     * The media stream of the called party has disconnected. This does not imply that the call has ended. When the call is ended, the callEnded method is called. This event can occur both when the called party hangs up, or when the application explicitly releases the leg using IpCallLeg.release() This cannot occur when the app explicitly releases the call leg and the call.
     */
    public static final int _CALL_REPORT_DISCONNECT =  6;

    /**
     * The media stream of the called party has disconnected. This does not imply that the call has ended. When the call is ended, the callEnded method is called. This event can occur both when the called party hangs up, or when the application explicitly releases the leg using IpCallLeg.release() This cannot occur when the app explicitly releases the call leg and the call.
     */
    public static final CallReportType CALL_REPORT_DISCONNECT = new CallReportType(_CALL_REPORT_DISCONNECT);

    /**
     * Call redirected to new address: an indication from the network that the call has been redirected to a new address.
     */
    public static final int _CALL_REPORT_REDIRECTED =  7;

    /**
     * Call redirected to new address: an indication from the network that the call has been redirected to a new address.
     */
    public static final CallReportType CALL_REPORT_REDIRECTED = new CallReportType(_CALL_REPORT_REDIRECTED);

    /**
     * Mid-call service code received.
     */
    public static final int _CALL_REPORT_SERVICE_CODE =  8;

    /**
     * Mid-call service code received.
     */
    public static final CallReportType CALL_REPORT_SERVICE_CODE = new CallReportType(_CALL_REPORT_SERVICE_CODE);

    /**
     * Call routing failed - re-routing is possible.
     */
    public static final int _CALL_REPORT_ROUTING_FAILURE =  9;

    /**
     * Call routing failed - re-routing is possible.
     */
    public static final CallReportType CALL_REPORT_ROUTING_FAILURE = new CallReportType(_CALL_REPORT_ROUTING_FAILURE);

    /**
     * The call is being held in a queue. This event may be sent more than once during the routing of a call.
     */
    public static final int _CALL_REPORT_QUEUED =  10;

    /**
     * The call is being held in a queue. This event may be sent more than once during the routing of a call.
     */
    public static final CallReportType CALL_REPORT_QUEUED = new CallReportType(_CALL_REPORT_QUEUED);

    /**
     * The called address is not reachable; for example the phone has been switched off or the phone is outside the coverage area of the network.
     */
    public static final int _CALL_REPORT_NOT_REACHABLE =  11;

    /**
     * The called address is not reachable; for example the phone has been switched off or the phone is outside the coverage area of the network.
     */
    public static final CallReportType CALL_REPORT_NOT_REACHABLE = new CallReportType(_CALL_REPORT_NOT_REACHABLE);


    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the CallReportType object
     */
    public String getValueText() {
        switch (_value) {
            case _CALL_REPORT_UNDEFINED:
                return "CALL_REPORT_UNDEFINED";
            case _CALL_REPORT_PROGRESS:
                return "CALL_REPORT_PROGRESS";
            case _CALL_REPORT_ALERTING:
                return "CALL_REPORT_ALERTING";
            case _CALL_REPORT_ANSWER:
                return "CALL_REPORT_ANSWER";
            case _CALL_REPORT_BUSY:
                return "CALL_REPORT_BUSY";
            case _CALL_REPORT_NO_ANSWER:
                return "CALL_REPORT_NO_ANSWER";
            case _CALL_REPORT_DISCONNECT:
                return "CALL_REPORT_DISCONNECT";
            case _CALL_REPORT_REDIRECTED:
                return "CALL_REPORT_REDIRECTED";
            case _CALL_REPORT_SERVICE_CODE:
                return "CALL_REPORT_SERVICE_CODE";
            case _CALL_REPORT_ROUTING_FAILURE:
                return "CALL_REPORT_ROUTING_FAILURE";
            case _CALL_REPORT_QUEUED:
                return "CALL_REPORT_QUEUED";
            case _CALL_REPORT_NOT_REACHABLE:
                return "CALL_REPORT_NOT_REACHABLE";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 11
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static CallReportType getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallReportType)) {
            return false;
        }
        CallReportType callReportType = (CallReportType) o; 
        if(!(this.getValue() == callReportType.getValue())) {
            return false;
        }
        if (this.hashCode() != callReportType.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallReportType

