//Source file: <name_of_source_file>
//Date: <date>
//<information>

package org.csapi.jr.se.cc.gccs;

/**
 * Defines the Sequence of Data Elements that specify the treatment for calls that will be handled only by the network (for example, call which are not admitted by the call load control mechanism).
 * 
 */
public final class CallTreatment implements java.io.Serializable {

    private org.csapi.jr.se.cc.CallTreatmentType callTreatmentType;
    private org.csapi.jr.se.cc.gccs.CallReleaseCause releaseCause;
    private org.csapi.jr.se.cc.CallAdditionalTreatmentInfo additionalTreatmentInfo;

    /**
     * Creates a new CallTreatment instance.
     */
    public CallTreatment () {}

    /**
     * Creates a new CallTreatment instance.
     * @param _callTreatmentType   
     * @param _releaseCause   
     * @param _additionalTreatmentInfo   
     */
    public CallTreatment (org.csapi.jr.se.cc.CallTreatmentType _callTreatmentType, org.csapi.jr.se.cc.gccs.CallReleaseCause _releaseCause, org.csapi.jr.se.cc.CallAdditionalTreatmentInfo _additionalTreatmentInfo) {

        this.callTreatmentType = _callTreatmentType;
        this.releaseCause = _releaseCause;
        this.additionalTreatmentInfo = _additionalTreatmentInfo;
    }

    /**
     * This method returns a callTreatmentType.
     * 
     * @return a org.csapi.jr.se.cc.CallTreatmentType value
     */
    public org.csapi.jr.se.cc.CallTreatmentType getCallTreatmentType() {
        return callTreatmentType;
    }

    /**
     * This method returns a releaseCause.
     * 
     * @return a org.csapi.jr.se.cc.gccs.CallReleaseCause value
     */
    public org.csapi.jr.se.cc.gccs.CallReleaseCause getReleaseCause() {
        return releaseCause;
    }

    /**
     * This method returns a additionalTreatmentInfo.
     * 
     * @return a org.csapi.jr.se.cc.CallAdditionalTreatmentInfo value
     */
    public org.csapi.jr.se.cc.CallAdditionalTreatmentInfo getAdditionalTreatmentInfo() {
        return additionalTreatmentInfo;
    }


    /**
     * This method sets a callTreatmentType.
     */ 
    public void setCallTreatmentType(org.csapi.jr.se.cc.CallTreatmentType callTreatmentType) {
        this.callTreatmentType = callTreatmentType;
    }

    /**
     * This method sets a releaseCause.
     */ 
    public void setReleaseCause(org.csapi.jr.se.cc.gccs.CallReleaseCause releaseCause) {
        this.releaseCause = releaseCause;
    }

    /**
     * This method sets a additionalTreatmentInfo.
     */ 
    public void setAdditionalTreatmentInfo(org.csapi.jr.se.cc.CallAdditionalTreatmentInfo additionalTreatmentInfo) {
        this.additionalTreatmentInfo = additionalTreatmentInfo;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof CallTreatment)) {
            return false;
        } 
        CallTreatment callTreatment = (CallTreatment) o;
        if ((this.callTreatmentType != null) && (callTreatment.callTreatmentType != null)) {
            if(!(this.callTreatmentType.equals(callTreatment.callTreatmentType))) {
                return false;
            }
        }
        if ((this.releaseCause != null) && (callTreatment.releaseCause != null)) {
            if(!(this.releaseCause.equals(callTreatment.releaseCause))) {
                return false;
            }
        }
        if ((this.additionalTreatmentInfo != null) && (callTreatment.additionalTreatmentInfo != null)) {
            if(!(this.additionalTreatmentInfo.equals(callTreatment.additionalTreatmentInfo))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // CallTreatment

