//Source file: GetCallInfoResEvent.java
//Date: February 2004
//Generic Call Control Interfaces for 3GPP TS 29.198-04-2 V6.0.0, Release 6

package org.csapi.jr.se.cc.gccs;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the getCallInfoRes() method on the callback interface 
 * has occured.<BR>
 *
 */
public final class GetCallInfoResEvent extends java.util.EventObject {

    /**
     * Constructor for the GetCallInfoResEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public GetCallInfoResEvent(java.lang.Object source,
        org.csapi.jr.se.cc.gccs.CallInfoReport callInfoReport) {

        super(source);
      this.callInfoReport = callInfoReport;
 
    }

    org.csapi.jr.se.cc.gccs.CallInfoReport callInfoReport;

    /**
     *  This method is used to retrieve the parameter value of 'callInfoReport' passed up
     *  from the Gateway in it's call to the getCallInfoRes() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'callInfoReport' used on creation of this event.
     */
    public org.csapi.jr.se.cc.gccs.CallInfoReport getCallInfoReport() {

        return this.callInfoReport;
    }
       
}

