//Source file: Route.java
//Date: February 2004
//Generic Call Control Interfaces for 3GPP TS 29.198-04-2 V6.0.0, Release 6

package org.csapi.jr.se.cc.gccs;

/**
 * This interface represents a Route activity object.<BR>
 *
 */
public interface Route extends org.csapi.jr.se.Activity {

    /**
     * Returns a reference to the Call responsible for creation of the Route.
     *
     * @return  A reference to the Call responsible for creation of the Route.
     */
    org.csapi.jr.se.cc.gccs.Call getCall();

    /**
     * Adds a RouteListener which is interested in events generated by the Route.
     *
     * @param  routeListener  A reference to the RouteListener which is to be added as
     *        a listener.
     */
    void addRouteListener(org.csapi.jr.se.cc.gccs.RouteListener routeListener);

    /**
     * Removes a RouteListener which is no longer interested events generated by the Route.
     *
     * @param  routeListener  A reference to the RouteListener which is to be removed as
     *        a listener.
     */
    void removeRouteListener(org.csapi.jr.se.cc.gccs.RouteListener routeListener);

    /**
     * Invokes the routeReq() method on the Parlay Gateway.
     */
    void routeReq(
           org.csapi.jr.se.cc.gccs.CallReportRequest[] responseRequested,
           org.csapi.jr.se.Address targetAddress,
           org.csapi.jr.se.Address originatingAddress,
           org.csapi.jr.se.Address originalDestinationAddress,
           org.csapi.jr.se.Address redirectingAddress,
           org.csapi.jr.se.cc.gccs.CallAppInfo[] appInfo)
      throws org.csapi.jr.se.PlatformException,
       java.lang.IllegalStateException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.InvalidAddressException,
       org.csapi.jr.se.UnsupportedAddressPlanException,
       org.csapi.jr.se.InvalidNetworkStateException,
       org.csapi.jr.se.InvalidCriteriaException,
       org.csapi.jr.se.InvalidEventTypeException;
}
